#! /usr/bin/python

#Fabio Eboli 16/Jan 2012
#used python 2.7.2 numpy for plotting and scipy for matlab saving
#from http://www.lfd.uci.edu/~gohlke/pythonlibs/
#TODO:
#gestire gli errori
#accettare sequenze di comandi
#accesso veloce ai files tramite interfaccia diretta da tastiera


from pylab import *
from owonbin_01 import *
import os
import sys
import scipy.io

key="h"
tracesdata=[]

while key!="q":
    current=os.getcwd()
    if key=="h": #ask help
        print("Commands: \n \
              h->help \n \
              q->exit \n \
              a->list all \n \
              d->list dir \n \
              u->up directory \n \
              e->enter in directory \n \
              f->list files \n \
              o->list owon readable files \n \
              s->show owon file details \n \
              l->load owon readable file \n \
              p->plot converted data \n \
              r->plot raw data \n \
              m->export matlab file \
              ")
        print("Command?")

    elif key=="u": #up one directory level
        print("Command up directory")
        os.chdir(current[0:current.rfind('\\')])
        current=os.getcwd()
        print("Current directory:-> "+current)
        print("Command?")

    elif key=="a": #list all
        print("Command list all content")
        current=os.getcwd()
        content=os.listdir(current)
        print("Current directory:-> "+current)
        print("All Directory Content: ")
        for i in range(len(content)):
            print(str(i+1)+" "+os.path.join(current,content[i]))
        print("Command?")
            
    elif key=="d": #list directories
        print("Command list only directories")
        current=os.getcwd()
        content=os.listdir(current)
        print("Current directory:-> "+current)
        print("Directories Only: ")
        j=1
        for i in range(len(content)):
            if(os.path.isdir(os.path.join(current,content[i]))):
                print(str(j)+" "+os.path.join(current,content[i]))
                j=j+1
        print("Command?")

    elif key=="e": #enter in the selected directory
        print("Command enter in selected directory")
        print("Available directories: ")
        current=os.getcwd()
        content=os.listdir(current)
        directories=[]
        for i in range(len(content)):
            if(os.path.isdir(os.path.join(current,content[i]))):
                directories.append(os.path.join(current,content[i]))
                print(str(len(directories))+" "+os.path.join(current,content[i]))
        sys.stdin.flush()
        dirno=raw_input("Directory number? ")
        print("Selected directory number "+dirno)
        dirn=0
        if dirno.isdigit():
            dirn=int(dirno)
        if ((dirn<len(directories)+1) & (dirn>0)):
            print("Directory: "+directories[dirn-1])
            os.chdir(directories[dirn-1])
        print("Command?")
            
    elif key=="f": #list files
        print("Command list only files")
        current=os.getcwd()
        content=os.listdir(current)
        print("Current directory:-> "+current)
        print("Files Only: ")
        j=1
        for i in range(len(content)):
            if(os.path.isfile(os.path.join(current,content[i]))):
                print(str(j)+" "+os.path.join(current,content[i]))
                j=j+1
        print("Command?")

    elif key=="o": #list owon readable files
        print("Command list only Owon data files")
        current=os.getcwd()
        content=os.listdir(current)
        print("Current directory:-> "+current)
        print("Owon Files Only: ")
        datafile=owonfile()
        for i in range(len(content)):
            if(os.path.isfile(os.path.join(current,content[i]))):
                datafile.FileIdentify(os.path.join(current,content[i]))
                if len(datafile.blocks)!=0:
                    print(str(i+1)+" "+os.path.join(current,content[i]))
        print("Command?")

    elif key=="s": #Show Owon file details
        print("Show Owon file details")
        print("Available Owon Files: ")
        datafile=owonfile()
        current=os.getcwd()
        content=os.listdir(current)
        files=[]
        for i in range(len(content)):
            if(os.path.isfile(os.path.join(current,content[i]))):
                datafile.FileIdentify(os.path.join(current,content[i]))
                if len(datafile.blocks)!=0:
                    print(str(len(files)+1)+" "+os.path.join(current,content[i]))
                    files.append(os.path.join(current,content[i]))
        sys.stdin.flush()
        fileno=raw_input("File number? ")
        print("Selected file number "+fileno)
        filen=0
        if fileno.isdigit():
            filen=int(fileno)
        if ((filen<len(files)+1) & (filen>0)):
            print("File: "+files[filen-1])
            datafile.FileIdentify(files[filen-1])
            datafile.PrintInfo()
        print("Command?")

    elif key=="l": #load owon data file
        print("Command load Owon data file")
        print("Available Owon Files: ")
        datafile=owonfile()
        current=os.getcwd()
        content=os.listdir(current)
        files=[]
        for i in range(len(content)):
            if(os.path.isfile(os.path.join(current,content[i]))):
                datafile.FileIdentify(os.path.join(current,content[i]))
                if len(datafile.blocks)!=0:
                    print(str(len(files)+1)+" "+os.path.join(current,content[i]))
                    files.append(os.path.join(current,content[i]))
        sys.stdin.flush()
        fileno=raw_input("File number? ")
        print("Selected file number "+fileno)
        filen=0
        if fileno.isdigit():
            filen=int(fileno)
        if ((filen<len(files)+1) & (filen>0)):
            print("File: "+files[filen-1])
            datafile.FileIdentify(files[filen-1])
            tracesdata=[]
            for i in range(len(datafile.blocks)):                
                trace=dsotrace()
                trace.LoadTraceParFromFile(files[filen-1],i)
                trace.LoadTraceDataFromFile(files[filen-1],i)
                tracesdata.append(trace)
                trace.PrintTraceInfo(i)
                print("Loaded trace "+tracesdata[i].Channel)
        print("Command?")

    elif key=="r": # plot raw data loaded
        print("Command plot raw data")
        print(str(len(tracesdata))+" Traces in memory: ")
        for i in range(len(tracesdata)):
            print("Trace "+str(i+1)+" Channel "+tracesdata[i].Channel)
        sys.stdin.flush()
        plotno=raw_input("Trace to plot? 1 to "+str(len(tracesdata))+" : ")
        if plotno.isdigit():
            plotn=int(plotno)        
        if ((plotn<(len(tracesdata)+1)) & (plotn>0)):
            print("Selected raw plotting trace "+str(plotn))
            print("Channel "+tracesdata[plotn-1].Channel)
            print("Plotting... ")
            plot(tracesdata[plotn-1].SamplesRaw, drawstyle='steps')
            axhline(y=127,color='b', linestyle=':')
            axhline(y=-128,color='b', linestyle=':')
            print("Show plot...")
            show()
        print("Command?")
        
    elif key=="p": #convert loaded raw data and plot
        print("Command plot converted data")
        print(str(len(tracesdata))+" Traces in memory: ")
        for i in range(len(tracesdata)):
            print("Trace "+str(i+1)+" Channel "+tracesdata[i].Channel)
        sys.stdin.flush()
        plotno=raw_input("Trace to plot? 1 to "+str(len(tracesdata))+" : ")
        if plotno.isdigit():
            plotn=int(plotno)        
        if ((plotn<(len(tracesdata)+1)) & (plotn>0)):
            print("Selected plotting trace "+str(plotn))
            print("Channel "+tracesdata[plotn-1].Channel+" converting...")
            tracesdata[plotn-1].Convert()
            print("Plotting... ")
            plot(tracesdata[plotn-1].TimeSamples,tracesdata[plotn-1].Samples, drawstyle='steps')
            axhline(y=tracesdata[plotn-1].ClipLevelH,color='b', linestyle=':')
            axhline(y=tracesdata[plotn-1].ClipLevelL,color='b', linestyle=':')
            print("Show plot...")
            show()
        print("Command?")

    elif key=="m": #export to matlab file
        print("Command export trace to matlab file")
        print(str(len(tracesdata))+" Traces in memory: ")
        for i in range(len(tracesdata)):
            print("Trace "+str(i+1)+" Channel "+tracesdata[i].Channel)
        sys.stdin.flush()
        plotno=raw_input("Trace to export? 1 to "+str(len(tracesdata))+" : ")
        if plotno.isdigit():
            plotn=int(plotno)        
        if ((plotn<(len(tracesdata)+1)) & (plotn>0)):
            print("Selected exporting trace "+str(plotn))
            print("Channel "+tracesdata[plotn-1].Channel+" converting...")
            tracesdata[plotn-1].Convert()
            matfile=(tracesdata[plotn-1].filename)[0:tracesdata[plotn-1].filename.rfind(".")]+"_"+tracesdata[plotn-1].Channel+".mat"
            print("Saving in "+matfile+"...")
            scipy.io.savemat(matfile,do_compression=True,oned_as='column',mdict= \
                             {tracesdata[plotn-1].Channel+'Samples':tracesdata[plotn-1].Samples,\
                              tracesdata[plotn-1].Channel+'Time':tracesdata[plotn-1].TimeSamples,\
                             })
            print("Saved")
        print("Command?")

        
    else:
        print("Hello: press h for help")
    sys.stdin.flush()
    key=sys.stdin.readline(1)
